# pybiotk: A python toolkit for bioinformatics analysis

## Install

> **SetuptoolsDeprecationWarning: setup.py install is deprecated. Use build and pip and other standards-based tools.**

### use PyPi(official)

```
pip install pybiotk
```

**An older version may be installed**

### use build frontend([build: A simple, correct PEP 517 build frontend.](https://pypi.org/project/build/))

```
git clone https://gitee.com/liqiming_whu/pybiotk.git
cd pybiotk
pip install build
python -m build
pip install dist/*tar.gz
```

### use setup.py sdist

```
git clone https://gitee.com/liqiming_whu/pybiotk.git
cd pybiotk
pip install cython
python setup.py sdist
pip install dist/*tar.gz
```

## Modules

```
console_scripts =
    gtf2bed = pybiotk.convert.gtf2bed:run
    bed2bedgraph = pybiotk.convert.bed2bedgraph:run
    fq2fasta = pybiotk.convert.fq2fasta:run
    bam2fastx = pybiotk.convert.bam2fastx:run
    bampe_order_by_name = pybiotk.convert.bampe_order_by_name:run
    bam_random = pybiotk.utils.bam_random:run
    gtf_filter = pybiotk.utils.gtf_filter:run
    fasta_filter = pybiotk.utils.fasta_filter:run
    fastq_uniq = pybiotk.utils.fastq_uniq:run
    seq_random = pybiotk.utils.seq_random:run
    merge_row = pybiotk.utils.merge_row:run
    read_tables = pybiotk.utils.read_tables:run
    rmats_filter = pybiotk.utils.rmats_filter:run
    count_normalize = pybiotk.utils.normalize:run
    reference_count = pybiotk.utils.reference_count:run
    pyanno = pybiotk.utils.pyanno:run
    rna_fragment_size = pybiotk.utils.fragment_size:run
    merge_subseq = pybiotk.utils.merge_subseq:run
    subseq_analysis = pybiotk.utils.subseq_analysis:run
```

## Usage

```
usage: pyanno [-h] -i INPUT -o OUTPUT -g GTF [-l {transcript,gene}] [--tss_region TSS_REGION [TSS_REGION ...]] [--downstream DOWNSTREAM] [-s]
              [--rule {1+-,1-+,2++,2--,1++,1--,2+-,2-+,+-,-+,++,--}] [-p] [--ordered_by_name]

optional arguments:
  -h, --help            show this help message and exit
  -i INPUT, --input INPUT
                        input file, bam or bed. The file type will be inferred from the filename suffix ['*.bam', '*.bed']. (default: None)
  -o OUTPUT, --output OUTPUT
                        output file name. (default: None)
  -g GTF, --gtf GTF     gtf file download from Genecode, or a sorted gtf file. (default: None)
  -l {transcript,gene}, --level {transcript,gene}
                        annotation level, transcript or gene. (default: transcript)
  --tss_region TSS_REGION [TSS_REGION ...]
                        choose region from tss. (default: [-1000, 1000])
  --downstream DOWNSTREAM
                        downstream length from tes. (default: 3000)
  -s, --strand          require same strandedness. (default: False)
  --rule {1+-,1-+,2++,2--,1++,1--,2+-,2-+,+-,-+,++,--}
                        how read(s) were stranded during sequencing. only for bam. (default: 1+-,1-+,2++,2--)
  -p, --pair            annotate fragments instead of reads. (default: False)
  --ordered_by_name     if input bam is ordered by name, only for pair-end bam. (default: False)
```

#!/usr/bin/env Rscript
library(argparse)
library(ggplot2)

parser <- ArgumentParser()
parser$add_argument('input', type="character", help='input file.')
parser$add_argument('-x', dest='x_lable', type="character", default='', help='x lab.')
parser$add_argument('-y', dest='y_lable', type="character", default='', help='y lab.')
parser$add_argument('-t', dest='title', type="character", default='', help='title.')
parser$add_argument('--noheader', dest='noheader', action='store_true', help='if no header.')
parser$add_argument('-o', dest='output', type="character", required=TRUE, help='output.')
parser$add_argument('-w', dest='width', type="integer", default=12, help='outfig width.')
parser$add_argument('-l', dest='length', type="integer", default=9, help='outfig length.')
parser$add_argument('-b', dest='bins', type="integer", default=30, help='bin nums.')
parser$add_argument('-f', dest='font_size', type="integer", default=12, help='font size.')

args <- parser$parse_args()

options(scipen=3)

if(args$noheader) {
    header <- FALSE
}else {
    header <- TRUE
}

df <- read.table(args$input, sep="\t", header=header)
names(df) <- c("Length")
stats <- boxplot.stats(df$Length)
df <- subset(df, Length < stats$stats[5] & Length > stats$stats[1])

p <- ggplot(df, aes(x=Length)) +
    geom_histogram(aes(y=..density..), position = "identity", fill="#FF000080", color="black", bins=args$bins, alpha=0.5) +
    geom_density() +
    labs(x=args$x_lable, y=args$y_lable, title=args$title) +
    theme_bw(base_size = 12) +
    theme(panel.grid=element_blank()) +
    theme(plot.title = element_text(hjust=0.5, face="bold", color="black", size=14)) +
    theme(axis.text.x = element_text(color='black',size=args$font_size)) +
    theme(axis.text.y = element_text(color='black',size=args$font_size)) +
    theme(panel.grid = element_blank())

ggsave(p, filename = args$output, width = args$width, height = args$length)

#!/usr/bin/env Rscript
library(argparse)

parser <- ArgumentParser()
parser$add_argument('input', type="character", help='bedfile')
parser$add_argument('-s', dest='species', type="character", default=NULL, help='hg38 or mm10')
parser$add_argument('-g', dest='gtf', type="character", default=NULL, help='gtf file')
parser$add_argument('-t', dest='tss', type="integer", nargs="+", default=c(-3000, 3000), help='tssRegion')
parser$add_argument('-o', dest='outdir', type="character", required=TRUE, help='output dir')
parser$add_argument('--strand', dest='strand', action='store_true', help='same strand')
parser$add_argument('-f', dest='fig', default=NULL, help='pdf or png')

args <- parser$parse_args()
bedfile <- args$input
species <- args$species
gtf <- args$gtf
tss <- args$tss
outdir <- args$outdir
samestrand <- args$strand
fig <- args$fig
ylab <- args$ylab

stopifnot(!(is.null(species) & is.null(gtf)))

library(ChIPseeker)

if(!is.null(gtf)) {
    library(GenomicFeatures)
    txdb <- makeTxDbFromGFF(file=gtf)
    annoDb <- NULL
}else {
    if(species == "hg38") {
    library(org.Hs.eg.db)
    library(TxDb.Hsapiens.UCSC.hg38.knownGene)
    txdb <- TxDb.Hsapiens.UCSC.hg38.knownGene
    annoDb <- "org.Hs.eg.db"
    }else if(species == "mm10") {
    library(org.Mm.eg.db)
    library(TxDb.Mmusculus.UCSC.mm10.knownGene)
    txdb <- TxDb.Mmusculus.UCSC.mm10.knownGene
    annoDb <- "org.Mm.eg.db"
    }else stop("species not support")
}

peak <- readPeakFile(bedfile)
peakAnno <- annotatePeak(
    peak,
    tssRegion = tss,
    TxDb = txdb,
    level = "transcript",
    assignGenomicAnnotation = TRUE,
    genomicAnnotationPriority = c("Promoter", "5UTR", "3UTR", "Exon", "Intron", "Downstream", "Intergenic"),
    annoDb = annoDb,
    addFlankGeneInfo = FALSE,
    flankDistance = 5000,
    sameStrand = samestrand,
    ignoreOverlap = FALSE,
    ignoreUpstream = FALSE,
    ignoreDownstream = FALSE,
    overlap = "TSS",
    verbose = TRUE
)

if(!dir.exists(outdir)) {
    dir.create(outdir, recursive=TRUE)
}

setwd(outdir)

anno <- as.data.frame(peakAnno)
write.table(anno,file="anno.xls",sep='\t',quote=F)

if(!is.null(fig)) {

    if(fig=="pdf") {
        pdf("AnnoPie.pdf")
    }else {
        png("AnnoPie.png")
    }
    plotAnnoPie(peakAnno)
    dev.off()

    if(fig=="pdf") {
        pdf("VennPie.pdf")
    }else {
        png("VennPie.png")
    }
    vennpie(peakAnno)
    dev.off()

    library(ggplot2)

    p <- plotAnnoBar(peakAnno, xlab="", ylab='Percentage(%)', title="Feature Distribution")
    ggsave(p, file=paste0("AnnoBar.", fig))

    p <- plotDistToTSS(peakAnno, distanceColumn="distanceToTSS", xlab="", ylab="Binding sites (%) (5'->3')",
        title="Distribution of transcription factor-binding loci relative to TSS")
    ggsave(p, file=paste0("dis2TSS.", fig))

    p <- upsetplot(peakAnno, vennpie = TRUE)
    ggsave(p, file=paste0("upset.", fig), width = 8, height = 10, bg="white")

    p <- covplot(peak)
    ggsave(p, file=paste0("cov.", fig), width = 20, height = 20)
}

#!/usr/bin/env Rscript
library(argparse)

parser <- ArgumentParser()
parser$add_argument('input', type="character", nargs='+', help='control and case')
parser$add_argument('-s', dest='samples', type="character", nargs='+', default=NULL, help='sample names.')
parser$add_argument('-g', dest='group', type="character", nargs='+', default=NULL, help='sample groups.')
parser$add_argument('-b', dest='by', type="integer", default=1, help='use columns to merge.')
parser$add_argument('-c', dest='column', type="integer", default=2, help='use column to calculate.')
parser$add_argument('-o', dest='outdir', type="character", required=TRUE, help='output dir')
parser$add_argument('-l', dest='log2fc', type="double", default=1.0, help='log2fc [default=1].')
parser$add_argument("-p", dest="padj_value", type="double", default=0.05, help="cutoff of padj_value [default=0.05].")
parser$add_argument('--spike-in', dest="spike_in", type="character", nargs='+', default=NULL, help='control and case spike_in.')

args <- parser$parse_args()
input_files <- args$input
samples_name <- args$samples
columns <- c(args$by, args$column)
outdir <- args$outdir
log2fc <- args$log2fc
padj_value <- args$padj_value
spike_in <- args$spike_in

input_files_len <- length(input_files)

filename_preix <- function(file_path) {
    name <- basename(file_path)
    name_vec <- strsplit(name, split=".", fixed=T)[[1]]
    return(name_vec[1])
}

if(!is.null(samples_name)) {
    stopifnot(input_files_len == length(samples_name))
}else {
    samples_name <- c()
    for(filename in input_files) {
        samples_name <- append(samples_name, filename_preix(filename))   
    }
}

library(DESeq2)

read_data <- function(filename, sample) {
    table <- read.table(filename, sep="\t", header=T)
    table <- table[, columns]
    names(table) <- c("id", sample)
    table <- table[complete.cases(table),]
    return(table)
}

table <- read_data(input_files[1], samples_name[1])
for (idx in seq_along(input_files)[-1]) {
    filename <- input_files[idx]
    sample_name <- samples_name[idx]
    data <- read_data(filename, sample_name)
    table <- merge(table, data, by="id", all=T)
}

table[is.na(table)] <- 0 

if (is.null(args$group)) {
    group_length <- input_files_len / 2
    group <- rep(c('control', 'treat'), each=group_length)
}else {
    group <- args$group
}

counts_table <- table[,-1]
rownames(counts_table) <- table[,1]

counts_table <- round(counts_table, digits=0) 
counts_table <- as.matrix(counts_table)
condition <- factor(group, levels=c("control", "treat"))
coldata <- data.frame(row.names=colnames(counts_table), condition)

dds <- DESeqDataSetFromMatrix(counts_table, coldata, design=~condition)

if(!is.null(spike_in)) {

    spike_table <- read_data(spike_in[1], samples_name[1])
    for (idx in seq_along(spike_in)[-1]) {
        filename <- spike_in[idx]
        sample_name <- samples_name[idx]
        data <- read_data(filename, sample_name)
        spike_table <- merge(spike_table, data, by="id", all=T)
    }

    spike_table[is.na(spike_table)] <- 0 
    spike_counts_table <- spike_table[,-1]
    rownames(spike_counts_table) <- spike_table[,1]

    spike_counts_table <- round(spike_counts_table, digits=0) 
    spike_counts_table <- as.matrix(spike_counts_table)
    spike_coldata <- data.frame(row.names=colnames(spike_counts_table), condition)
    spike_dds <- DESeqDataSetFromMatrix(spike_counts_table, spike_coldata, design=~condition)
    spike_dds <- estimateSizeFactors(spike_dds)

    sizeFactors(dds) <- sizeFactors(spike_dds)
}

dds <- DESeq(dds) # This function performs a default analysis through the steps:
# dds <- estimateSizeFactors(dds)
# dds <- estimateDispersions(dds)
# dds <- nbinomWaldTest(dds)

res <- results(dds)

if(!dir.exists(outdir)) {
    dir.create(outdir, recursive=TRUE)
}

setwd(outdir)

res <- res[order(res$padj),]
res <- merge(as.data.frame(res), as.data.frame(counts(dds, normalize=T)),
             by="row.names", sort=F)
deseq_res <- data.frame(res)

up_diff <- subset(deseq_res, (padj < padj_value) & (log2FoldChange > log2fc))
down_diff <- subset(deseq_res, (padj < padj_value) & (log2FoldChange < -log2fc))
sig_result <- subset(deseq_res, (padj < padj_value) & (abs(log2FoldChange) > log2fc))
all_result <- subset(deseq_res, baseMean != 0)

fpm_table <- fpm(dds)

write.table(up_diff, "up.xls", quote=F, row.names=F, col.names=T, sep="\t")
write.table(down_diff, "down.xls", quote=F, row.names=F, col.names=T, sep="\t")
write.table(sig_result, "sig.xls", quote=F, row.names=F, col.names=T, sep="\t")
write.table(all_result, "all.xls", quote=F, row.names=T, col.names=T, sep="\t")
write.table(fpm_table, "cpm.xls", quote=F, row.names=T, col.names=T, sep="\t")

#!/usr/bin/env Rscript
library(argparse)

parser <- ArgumentParser()
parser$add_argument('input', type="character", nargs='+', help='input files.')
parser$add_argument('-s', dest='samples', type="character", nargs='+', default=NULL, help='sample names.')
parser$add_argument('--noheader', dest='noheader', action='store_true', help='if no header.')
parser$add_argument('-b', dest='by_columns', type="integer", nargs='+', required=TRUE, help='use columns to merge.')
parser$add_argument('-c', dest='column', type="integer", required=TRUE, help='use column to calculate.')
parser$add_argument('-o', dest='outdir', type="character", required=TRUE, help='output dir')
parser$add_argument('-p', dest='pdf', action='store_true', help='pdf or png')
parser$add_argument('-m', dest='min_lable', type="double", default=NULL, help='min lable')
parser$add_argument('--break', dest='breaklen', type="double", default=0.05, help='break length')

args <- parser$parse_args()

library(pheatmap)          
library(corrplot)                                                                                                                                                               
library(RColorBrewer)

input_files <- args$input
samples_name <- args$samples
by_columns <- args$by_columns
column <- args$column
columns <- append(by_columns, column)
outdir <- args$outdir
pdf <- args$pdf
min_lable <- args$min_lable

if(!dir.exists(outdir)) {
    dir.create(outdir, recursive=TRUE)
}

if(args$noheader) {
    header <- FALSE
}else {
    header <- TRUE
}

filename_preix <- function(file_path) {
    name <- basename(file_path)
    name_vec <- strsplit(name, split=".", fixed=T)[[1]]
    return(name_vec[1])
}

if(!is.null(samples_name)) {
    stopifnot(length(input_files) == length(samples_name))
}else {
    samples_name <- c()
    for(filename in input_files) {
        samples_name <- append(samples_name, filename_preix(filename))   
    }
}

by_columns_len <- length(by_columns)
bycolumns <- 1:by_columns_len

read_data <- function(filename, sample) {
    table <- read.table(filename, sep="\t", header=header)
    table <- table[, columns]
    rawcolnames <- colnames(table)[1:by_columns_len]
    names(table) <- c(rawcolnames, sample)
    table <- table[complete.cases(table),]
    return(table)
}

all_data <- read_data(input_files[1], samples_name[1])
for (idx in seq_along(input_files)[-1]) {
    filename <- input_files[idx]
    sample_name <- samples_name[idx]
    table <- read_data(filename, sample_name)
    all_data <- merge(all_data, table, by=bycolumns, all=T)
}

us_count <- subset(all_data,select=-bycolumns)
if(by_columns_len == 1){
    rownames(us_count) <- all_data[,1]
}
us_count[is.na(us_count)] <- 0
us_count <- us_count[rowSums(us_count) > 0,]
us_count <- cor(us_count, use='everything', method='pearson')
write.table(us_count, file=file.path(outdir, "corr.tsv"), sep="\t")

if(pdf) {
    pdf(file.path(outdir, "heatmap.pdf"))
}else {
    png(file.path(outdir, "heatmap.png"))
}

if (is.null(min_lable)) {
pheatmap(
  us_count,
  clustering_distance_rows = "correlation", 
  clustering_distance_cols = "correlation", 
  )
}else {
    breaksList <- seq(min_lable, 1, by=args$breaklen)
pheatmap(
  us_count,
  clustering_distance_rows = "correlation", 
  clustering_distance_cols = "correlation", 
  color = colorRampPalette(rev(brewer.pal(n=7,name = "RdYlBu")))(length(breaksList)),
  breaks = breaksList
  )
}
dev.off()

if(pdf) {
    pdf(file.path(outdir, "corr.pdf"))
}else {
    png(file.path(outdir, "corr.png"))
}
col <- colorRampPalette(c("green", "white", "red"))
corrplot(us_count, tl.col = "black", order="origin", col=col(100),)
dev.off()

#!/usr/bin/env Rscript
library(argparse)
library(ggplot2)
library(viridis)

parser <- ArgumentParser()
parser$add_argument(dest="input", type="character", nargs='+', help='input files.')
parser$add_argument('-s', dest='samples', type="character", nargs='+', default=NULL, help='sample names.')
parser$add_argument('--noheader', dest='noheader', action='store_true', help='if no header.')
parser$add_argument('-b', dest='by_columns', type="integer", nargs='+', required=TRUE, help='use columns to merge.')
parser$add_argument('-c', dest='column', type="integer", required=TRUE, help='use column to calculate.')
parser$add_argument('-o', dest='outfig', type="character", required=TRUE, help='output fig')
parser$add_argument('--drop_low', dest='drop', action="store_true", help='remove < 1 rows.')
parser$add_argument('--density', dest='density', action="store_true", help='plot density')

args <- parser$parse_args()

input_files <- args$input
samples_name <- args$samples
by_columns <- args$by_columns
column <- args$column
columns <- append(by_columns, column)


if(args$noheader) {
    header <- FALSE
}else {
    header <- TRUE
}

filename_preix <- function(file_path) {
    name <- basename(file_path)
    name_vec <- strsplit(name, split=".", fixed=T)[[1]]
    return(name_vec[1])
}

stopifnot(length(input_files) == 2)

if(!is.null(samples_name)) {
    stopifnot(length(input_files) == length(samples_name))
}else {
    samples_name <- c()
    for(filename in input_files) {
        samples_name <- append(samples_name, filename_preix(filename))   
    }
}

by_columns_len <- length(by_columns)
bycolumns <- 1:by_columns_len

read_data <- function(filename, sample) {
    table <- read.table(filename, sep="\t", header=header)
    table <- table[, columns]
    rawcolnames <- colnames(table)[1:by_columns_len]
    names(table) <- c(rawcolnames, sample)
    table <- table[complete.cases(table),]
    return(table)
}

data1 <- read_data(input_files[1], "x")
data2 <- read_data(input_files[2], "y")

all_data <- merge(data1, data2, by=bycolumns, all=T)

data <- subset(all_data,select=-bycolumns)

data[is.na(data)] <- 0
data <- data[rowSums(data) > 0,]
if(args$drop) data <- data[apply(data, 1, min) >= 1,]
correlation <- round(cor(data$x, data$y, use="everything", method="pearson"), 2)

label <- paste0("R = ", as.character(correlation))

log10_x <- log10(data$x)[!is.infinite(log10(data$x))]

p <- ggplot(data) +
    geom_point(aes(x=log10(x), y=log10(y)), color="blue") +
    geom_text(aes(x=min(log10_x) + 0.05*(max(log10_x) - min(log10_x)), y=max(log10(y))), label=label, size = 4, check_overlap=T) +
    labs(x=paste0(samples_name[1]," log10(FPKM)"), y=paste0(samples_name[2], " log10(FPKM)")) +
    theme_bw(base_size = 12) +
    theme(panel.grid=element_blank(), legend.position="none")

if(args$density) {
    p <- p + stat_density2d(geom = 'polygon', aes(x=log10(x), y=log10(y), fill=..level..)) +
        scale_fill_viridis(begin = 0.1, end = 0.9, option = "turbo", alpha = 0.8)
}

ggsave(args$outfig, p)

#!/usr/bin/env Rscript
library(argparse)

parser <- ArgumentParser()
parser$add_argument('input', type="character", nargs='+', help='control and case count tables')
parser$add_argument('-s', dest='samples', type="character", nargs='+', default=NULL, help='sample names.')
parser$add_argument('-g', dest='group', type="character", nargs='+', default=NULL, help='sample groups.')
parser$add_argument('-b', dest='by', type="integer", default=1, help='use columns to merge.')
parser$add_argument('-c', dest='column', type="integer", default=2, help='use column to calculate.')
parser$add_argument('-o', dest='outdir', type="character", required=TRUE, help='output dir')
parser$add_argument('-l', dest='log2fc', type="double", default=1.0, help='log2fc [default=1].')
parser$add_argument("-p", dest="padj_value", type="double", default=0.05, help="cutoff of padj_value [default=0.05].")
parser$add_argument('--bcv', dest='bcv', type="double", default=0.1, help='bcv value. [default=0.1].')
parser$add_argument('--housekeeping', dest='housekeeping', type="character", default=NULL, help='housekeeping genes for estimate dispersions.')
parser$add_argument('--spkie-in', dest="spike_in", type="character", nargs='+', default=NULL, help='control and case spike_in count tables.')

args <- parser$parse_args()
input_files <- args$input
samples_name <- args$samples
columns <- c(args$by, args$column)
outdir <- args$outdir
log2fc <- args$log2fc
padj_value <- args$padj_value
spike_in <- args$spike_in

input_files_len <- length(input_files)

filename_preix <- function(file_path) {
    name <- basename(file_path)
    name_vec <- strsplit(name, split=".", fixed=T)[[1]]
    return(name_vec[1])
}

if(!is.null(samples_name)) {
    stopifnot(input_files_len == length(samples_name))
}else {
    samples_name <- c()
    for(filename in input_files) {
        samples_name <- append(samples_name, filename_preix(filename))   
    }
}

library(edgeR)

read_data <- function(filename, sample) {
    table <- read.table(filename, sep="\t", header=T)
    table <- table[, columns]
    names(table) <- c("id", sample)
    table <- table[complete.cases(table),]
    return(table)
}

table <- read_data(input_files[1], samples_name[1])
for (idx in seq_along(input_files)[-1]) {
    filename <- input_files[idx]
    sample_name <- samples_name[idx]
    data <- read_data(filename, sample_name)
    table <- merge(table, data, by="id", all=T)
}

table[is.na(table)] <- 0 

if (is.null(args$group)) {
    group_length <- input_files_len / 2
    group <- rep(c('control', 'treat'), each=group_length)
}else {
    group <- args$group
}

# 构建DGEList对象
dgelist <- DGEList(counts = table[,-1], genes = table[,1], group=group)

# 过滤低表达基因，两种方式

# 1.直接依据选定的count值过滤
# keep <- rowSums(dgelist$counts) >= 50

# 2.CPM标准化
# keep <- rowSums(cpm(dgelist)>1) >= 1

# 3.自动过滤
keep<- filterByExpr(deglist, group=group)

dgelist <- dgelist[keep, , keep.lib.sizes=FALSE]

if(!is.null(spike_in)) {

    spike_table <- read_data(spike_in[1], samples_name[1])
    for (idx in seq_along(spike_in)[-1]) {
        filename <- spike_in[idx]
        sample_name <- samples_name[idx]
        data <- read_data(filename, sample_name)
        spike_table <- merge(spike_table, data, by="id", all=T)
    }

    spike_table[is.na(spike_table)] <- 0
    spike_dgelist <- DGEList(counts = spike_table[,-1], genes = spike_table[,1], group=group)
    spike_dgelist <- calcNormFactors(dgelist, method='TMM')

    deglist$samples$norm.factors <- spike_dgelist$samples$norm.factors
}else{
# 计算标准化因子，TMM
dgelist <- calcNormFactors(dgelist, method='TMM')
}

if(is.null(args$housekeeping)) {
    if (args$bcv){
        # 1.自定义离散值
        bcv <- args$bcv
        et <- exactTest(dgelist, dispersion = bcv ^ 2)
        genes <- decideTestsDGE(et, p.value=0.05, lfc=0)
        summary(genes)
        result <- cbind(dgelist$genes,dgelist$counts,et$table)
    }else{
        # 2.估算离散值(有重复)
        design <- model.matrix(~group)
        deglist <- estimateDisp(dgelist, design, robust=TRUE)
        fit <- glmFit(dgelist, design, robust=TRUE)
        lrt <- glmLRT(fit)
        genes <- decideTestsDGE(lrt, p.value=0.05, lfc = 0)
        summary(genes)
        result <- cbind(dgelist$genes,dgelist$counts,lrt$table)
    }
}else {
# 3.根据已知一些不会发生改变的基因推测离散值
    housekeeping_list <- read.table(args$housekeeping, header=F)
    housekeeping_list <- housekeeping_list[,1]
    genes <- dgelist$genes[, 1]
    housekeeping <- which(genes %in% housekeeping_list)
    dge <- dgelist
    dge$samples$group <- 1
    rownames(dge$counts) <- dgelist$genes[, 1]
    dge <- estimateDisp(dge[housekeeping,], trend="none", tagwise=FALSE, robust=TRUE)
    dgelist$common.dispersion <- dge$common.dispersion
    design <- model.matrix(~group)
    fit <- glmFit(dgelist, design, robust=TRUE)
    lrt <- glmLRT(fit)
    genes <- decideTestsDGE(lrt, p.value=0.05,lfc = 0)
    summary(genes)
    result <- cbind(dgelist$genes,dgelist$counts,lrt$table)
}

if(!dir.exists(outdir)) {
    dir.create(outdir, recursive=TRUE)
}

setwd(outdir)

result$Count <- rowSums(result[, 2:(2+input_files_len-1)])
up_diff <- subset(result, logFC > log2fc)
down_diff <- subset(result, logFC < -log2fc)
sig_result <- subset(result, abs(logFC) > log2fc)

write.table(up_diff, "up.xls", quote=F, row.names=F, col.names=T, sep="\t")
write.table(down_diff, "down.xls", quote=F, row.names=F, col.names=T, sep="\t")
write.table(sig_result, "sig.xls", quote=F, row.names=F, col.names=T, sep="\t")
write.table(result, "all.xls", quote=F, row.names=F, col.names=T, sep="\t")

#!/usr/bin/env Rscript
library(argparse)

parser <- ArgumentParser()
parser$add_argument('input', type="character", help='inputfile')
parser$add_argument('-c', dest='columns', type="integer", nargs="+", help='use columns to plot, order:gene, basemean, log2fc, padj')
parser$add_argument('-o', dest='output', type="character", required=TRUE, help='output')
parser$add_argument('-t', dest='title', type="character", default="", help='title')
parser$add_argument('-l', dest='log2fc', type="double", default=1.0, help='cutoff of log2fc')
parser$add_argument('-p', dest='padj_value', type="double", default=0.05, help='cutoff of padj_value, or pvalue')
parser$add_argument('-f', dest='font_size', type="integer", default=8, help='font size')
parser$add_argument('--nudge_x', dest='nudge_x', type="double", default=0, help='nudge_x')
parser$add_argument('--nudge_y', dest='nudge_y', type="double", default=0, help='nudge_y')
parser$add_argument('--box_padding', dest='box_padding', type="double", default=0.35, help='box_padding')
parser$add_argument('--labels', dest='labels', type="character", nargs="+", default=NULL, help="labels list")
parser$add_argument('--plot-type', dest='plot_type', type="character", default="volcano", help='plot type, volcano, ma, rank')


args <- parser$parse_args()

data_table <- args$input
columns <- args$columns
output <- args$output
title <- args$title
log2fc <- args$log2fc
padj_value <- args$padj_value
font_size <- args$font_size
nudge_x <- args$nudge_x
nudge_y <- args$nudge_y
box_padding <- args$box_padding
labels <- args$labels
plot_type <- args$plot_type


library(ggplot2)
library(ggrepel)
library(ggpubr)

.lwd <- ggplot2::.pt / ggplot2::.stroke
gg_lwd_convert <- function(value, unit = "pt") {

  # convert input type to mm
  value_out <- grid::convertUnit(grid::unit(value, unit), "mm", valueOnly = TRUE)

  # return with conversion factor
  return(
    value_out / .lwd
  )
}

volcano.plot <- function(data, path, title="", labels=NULL, up_label=5, down_label=5) {
  names(data) <- c("gene_id", "baseMean", "log2FoldChange", "padj")
  data <- na.omit(data)
  data$threshold <- as.factor(ifelse(data$padj <= padj_value & abs(data$log2FoldChange) >= log2fc,
                                     ifelse((data$log2FoldChange) >= log2fc ,'up','down'),'not'))

  up.count <- nrow(data[data$threshold=="up",])
  down.count <- nrow(data[data$threshold=="down",])

  data$label <- "NS"
  if(up.count > 0) data[data$threshold=="up",]$label <- paste0("Up: ", up.count)
  if(down.count > 0) data[data$threshold=="down",]$label <- paste0("Down: ", down.count)

  data$label <- factor(data$label, levels = c(paste0("Up: ", up.count), paste0("Down: ", down.count), "NS"))

  if(nrow(data[data$padj==0,]) > 0) data[data$padj==0,]$padj <- .Machine$double.xmin
  max.y <- max(-log10(data$padj))
  max.x <- max(data$log2FoldChange)
  min.x <- min(data$log2FoldChange)

  if(!is.null(labels)){
    need_label <- data[data$gene_id%in%labels,]
    need_label$color = "black"
  }else{
    label_data <- data[!data$threshold=='not',]
    if(nrow(label_data) > 0) label_data$pos <- 'middle'
    label_data <- label_data[order(label_data$log2FoldChange), ]
    dnrow <- nrow(label_data[label_data$threshold=='down', ])
    if(dnrow > down_label) down_cut <- down_label else down_cut <- dnrow
    label_data[1:dnrow, 'pos'] <- 'down'
    label_data[1:dnrow, 'color'] <- '#546de5'

    unrow <- nrow(label_data[label_data$threshold=='up', ])
    if(unrow > up_label) up_cut <- up_label else up_cut <- unrow

    label_data[(nrow(label_data)-up_cut+1):nrow(label_data), 'pos'] <- 'up'
    label_data[(nrow(label_data)-up_cut+1):nrow(label_data), 'color'] <- '#ff4757'

    need_label <- label_data[c(1:down_cut, (nrow(label_data)-up_cut+1):nrow(label_data)),]
    need_label <- need_label[nchar(need_label$gene_id) < 10,]
  }

  max.overlaps = getOption("ggrepel.max.overlaps", default = Inf)

  cols = setNames(c("#B31B21", "#1465AC", "darkgray"), c(paste0("Up: ", up.count), paste0("Down: ", down.count), "NS"))
  p <- ggplot(data=data, aes(x=log2FoldChange, y=-log10(padj), color=label, fill=label)) +
    scale_color_manual(values=cols) +
    geom_point(size=0.4, alpha=1) +
    geom_vline(xintercept=c(-log2fc, log2fc), linetype=2, color="black", linewidth=gg_lwd_convert(1)) +
    geom_hline(yintercept=-log10(padj_value), linetype=2, color="black", linewidth=gg_lwd_convert(1)) +
    # geom_text(x=0.5*min.x, y=1.02*max.y, label= paste0("down: ", as.character(down.count)), size = font_size/3, color="black", check_overlap=T) +
    # geom_text(x=0.5*max.x, y=1.02*max.y, label= paste0("up: ", as.character(up.count)), size = font_size/3, color="black", check_overlap=T) +
    geom_text_repel(data=need_label, aes(x=log2FoldChange, y=-log10(padj), label=gene_id), color="black", na.rm=T, force = 1, seed=42, segment.colour="black",
                    box.padding = unit(box_padding, "lines"), point.padding = unit(0.3, "lines"), size=font_size/3, direction="both", nudge_x=nudge_x, nudge_y=nudge_y,
                    min.segment.length = 0, max.overlaps=max.overlaps) +
    theme_bw(base_size=font_size) +
    theme(
      panel.grid=element_blank(),
      panel.border = element_rect(color="black", linewidth=gg_lwd_convert(1)),
      axis.line = element_blank(),
      legend.position="right",
      legend.title = element_blank(),
      legend.text= element_text(color="black", size=font_size),
      plot.title = element_text(hjust=0.5, color="black", size=font_size),
      axis.text = element_text(color="black", size=font_size),
      axis.title = element_text(color="black", size=font_size),
    ) +
    labs(x="Log2 fold change",y="-Log10 p-adjust",title=title)

  ggsave(path, p, width=12, height=9, unit="cm", dpi=300)

}


.levels <- function(x){
  if(!is.factor(x)) x <- as.factor(x)
  levels(x)
}

.parse_font <- function(font){
  if(is.null(font)) res <- NULL
  else if(inherits(font, "list")) res <- font
  else{
    # matching size and face
    size <- grep("^[0-9]+$", font, perl = TRUE)
    face <- grep("plain|bold|italic|bold.italic", font, perl = TRUE)
    if(length(size) == 0) size <- NULL else size <- as.numeric(font[size])
    if(length(face) == 0) face <- NULL else face <- font[face]
    color <- setdiff(font, c(size, face))
    if(length(color) == 0) color <- NULL
    res <- list(size=size, face = face, color = color)
  }
  res
}

ggmaplot <- function (data, fdr = 0.05, log2fc = 1.5, genenames = NULL,
                      detection_call = NULL, size = NULL, alpha = 1,
                      seed = 42,
                      font.label = c(12, "plain", "black"), label.rectangle = FALSE,
                      palette = c("#B31B21", "#1465AC", "darkgray"),
                      top = 15, select.top.method = c("padj", "fc"),
                      label.select = NULL,
                      main = NULL, xlab = "Log2 mean expression",  ylab = "Log2 fold change",
                      ggtheme = theme_classic(),...)
{

  if(!base::inherits(data, c("matrix", "data.frame", "DataFrame", "DE_Results", "DESeqResults")))
    stop("data must be an object of class matrix, data.frame, DataFrame, DE_Results or DESeqResults")
  if(!is.null(detection_call)){
    if(nrow(data)!=length(detection_call))
      stop("detection_call must be a numeric vector of length = nrow(data)")
  }
  else if("detection_call" %in% colnames(data)){
    detection_call <- as.vector(data$detection_call)
  }
  else detection_call = rep(1, nrow(data))

  # Legend position
  if(is.null(list(...)$legend)) legend <- c(0.12, 0.9)
  # If basemean logged, we'll leave it as is, otherwise log2 transform
  is.basemean.logged <- "baseMeanLog2" %in% colnames(data)
  if(is.basemean.logged){
    data$baseMean <- data$baseMeanLog2
  }
  else if("baseMean" %in% colnames(data)){
    data$baseMean <- log2(data$baseMean +1)
  }

  # Check data format
  ss <- base::setdiff(c("baseMean", "log2FoldChange", "padj"), colnames(data))
  if(length(ss)>0) stop("The colnames of data must contain: ",
                        paste(ss, collapse = ", "))

  if(is.null(genenames)) genenames <- rownames(data)
  else if(length(genenames)!=nrow(data))
    stop("genenames should be of length nrow(data).")

  sig <- rep(3, nrow(data))
  sig[which(data$padj <= fdr & data$log2FoldChange < 0 & abs(data$log2FoldChange) >= log2fc & detection_call ==1)] = 2
  sig[which(data$padj <= fdr & data$log2FoldChange > 0 & abs(data$log2FoldChange) >= log2fc & detection_call ==1)] = 1
  data <- data.frame(name = genenames, mean = data$baseMean, lfc = data$log2FoldChange,
                     padj = data$padj, sig = sig)

  # Change level labels
  . <- NULL
  data$sig <- as.factor(data$sig)
  .lev <- .levels(data$sig) %>% as.numeric()
  palette <- palette[.lev]
  new.levels <- c(
    paste0("Up: ", sum(sig == 1)),
    paste0("Down: ", sum(sig == 2)),
    "NS"
  ) %>% .[.lev]

  data$sig <- factor(data$sig, labels = new.levels)

  # Ordering for selecting top gene
  select.top.method <- match.arg(select.top.method)
  if(select.top.method == "padj") data <- data[order(data$padj), ]
  else if(select.top.method == "fc") data <- data[order(abs(data$lfc), decreasing = TRUE), ]
  # select data for top genes
  complete_data <- stats::na.omit(data)
  labs_data <- subset(complete_data, padj <= fdr & name!="" & abs(lfc) >= log2fc)
  labs_data <- utils::head(labs_data, top)
  # Select some specific labels to show
  if(!is.null(label.select)){
    selected_labels  <- complete_data %>%
      subset(complete_data$name  %in% label.select, drop = FALSE)
    labs_data <- dplyr::bind_rows(labs_data, selected_labels) %>%
      dplyr::distinct(.data$name, .keep_all = TRUE)
  }

  font.label <- .parse_font(font.label)
  font.label$size <- ifelse(is.null(font.label$size), 12, font.label$size)
  font.label$color <- ifelse(is.null(font.label$color), "black", font.label$color)
  font.label$face <- ifelse(is.null(font.label$face), "plain", font.label$face)

  # Plot
  mean <- lfc <- sig <- name <- padj <-  NULL
  p <- ggplot(data, aes(x = mean, y = lfc)) +
    geom_point(aes(color = sig), size = size, alpha = alpha)

  max.overlaps = getOption("ggrepel.max.overlaps", default = Inf)

  if(label.rectangle){
    p <- p + ggrepel::geom_label_repel(data = labs_data, mapping = aes(label = name),
                                       box.padding = unit(box_padding, "lines"),
                                       point.padding = unit(0.3, "lines"),
                                       force = 1, seed = seed, fontface = font.label$face,
                                       size = font.label$size/3, color = font.label$color,
                                       direction="both", nudge_x=nudge_x, nudge_y=nudge_y,
                                       max.overlaps = max.overlaps)
  }
  else{
    p <- p + ggrepel::geom_text_repel(data = labs_data, mapping = aes(label = name),
                                      box.padding = unit(box_padding, "lines"),
                                      point.padding = unit(0.3, "lines"),
                                      force = 1, seed = seed, fontface = font.label$face,
                                      size = font.label$size/3, color = font.label$color,
                                      direction="both", nudge_x=nudge_x, nudge_y=nudge_y,
                                      max.overlaps = max.overlaps)
  }

  p <- p + scale_x_continuous(breaks=seq(0, max(data$mean), 2))+
    labs(x = xlab, y = ylab, title = main, color = "")+ # to remove legend title use color = ""
    geom_hline(yintercept = c(0, -log2fc, log2fc), linetype = c(1, 2, 2),
               color = c("black", "black", "black"), linewidth=gg_lwd_convert(1))

  p <- ggpar(p, palette = palette, ggtheme = ggtheme, ...)
  p
}


ma.plot <-function(data, path, title="", labels=NULL) {
  names(data) <- c("gene_id", "baseMean", "log2FoldChange", "padj")
  data <- na.omit(data)
  p <- ggmaplot(
    data,
    fdr = padj_value,
    log2fc = log2fc,
    genenames = as.vector(data$gene_id),
    size = 0.4,
    alpha = 1,
    seed = 42,
    font.label = c(font_size, "plain", "black"),
    label.rectangle = FALSE,
    palette = c("#B31B21", "#1465AC", "darkgray"),
    select.top.method = "padj",
    top = 10,
    label.select = labels,
    main = title,
    xlab = "Log2 mean expression",
    ylab = "Log2 fold change",
    ggtheme = theme_bw(base_size = font_size)+
      theme(
        panel.grid=element_blank(),
        panel.border = element_rect(color="black", linewidth=gg_lwd_convert(1)),
        axis.line = element_blank(),
        legend.position="right",
        legend.title = element_blank(),
        legend.text= element_text(color="black", size=font_size),
        plot.title = element_text(hjust=0.5, color="black", size=font_size),
        axis.text.x = element_text(color="black", size=font_size),
        axis.text.y = element_text(color="black", size=font_size),
        axis.title.x = element_text(color="black", size=font_size),
        axis.title.y = element_text(color="black", size=font_size),
      )
  )
  ggsave(path, p, width=12, height=9, unit="cm", dpi=300)
}


rank.plot <- function(data, path, title="", labels=NULL) {
  names(data) <- c("gene_id", "baseMean", "log2FoldChange", "padj")
  data$threshold <- as.factor(ifelse(data$padj <= padj_value & abs(data$log2FoldChange) >= log2fc,
                                     ifelse((data$log2FoldChange) >= log2fc ,'up','down'),'not'))
  up.count <- nrow(data[data$threshold=="up",])
  down.count <- nrow(data[data$threshold=="down",])
  rank_data <- data[data$padj < padj_value,]
  rank_data$pos <- 'NS'
  rank_data <- rank_data[order(rank_data$log2FoldChange), ]
  rank_data$rank <- 1:nrow(rank_data)
  dnrow <- nrow(rank_data[rank_data$threshold=='down', ])
  marks <- c()
  if(dnrow > 5) down_cut <- 5 else down_cut <- dnrow
  if(dnrow > 0) {
    rank_data[1:dnrow, 'pos'] <- paste0("Down: ", dnrow)
    marks <- append(marks, rank_data[1:down_cut,]$gene_id)
  }

  unrow <- nrow(rank_data[rank_data$threshold=='up', ])
  if(unrow > 5) up_cut <- 5 else up_cut <- unrow
  if(unrow > 0) {
    rank_data[(nrow(rank_data)-unrow+1):nrow(rank_data), 'pos'] <- paste0("UP: ", unrow)
    marks <- append(marks, rank_data[(nrow(rank_data)-up_cut+1):nrow(rank_data),]$gene_id)
  }

  rank_data$pos <- factor(rank_data$pos, levels = c(paste0("UP: ", unrow), paste0("Down: ", dnrow), "NS"))

  if(!is.null(labels)){
    need_rank <- rank_data[rank_data$gene_id%in%labels,]
   }else{
    need_rank <- rank_data[rank_data$gene_id%in%marks,]
   }

  max.overlaps = getOption("ggrepel.max.overlaps", default = Inf)

  cols = setNames(c("#B31B21", "#1465AC", "darkgray"), c(paste0("Up: ", up.count), paste0("Down: ", down.count), "NS"))
  plot <- ggplot(data=rank_data, aes(x=rank, y=log2FoldChange, fill=pos)) +
        scale_color_manual(values=cols) +
        geom_point(size=0.4, alpha=1) +
        geom_hline(yintercept=c(-log2fc, log2fc), linetype=1, color="grey", linewidth=0.6) +
        geom_hline(yintercept=0, linetype=1, color="grey", linewidth=0.6) +
        geom_text_repel(inherit.aes=F, data=need_rank,
            aes(x=rank, y=log2FoldChange, label=gene_id), color="black", na.rm=T, force = 1, seed=42, segment.colour="black",
                    box.padding = unit(box_padding, "lines"), point.padding = unit(0.3, "lines"), size=font_size/3, direction="both", nudge_x=nudge_x, nudge_y=nudge_y,
                    min.segment.length = 0, max.overlaps=max.overlaps) +
        theme_bw(base_size=font_size) +
        theme(panel.grid=element_blank(),
              panel.border = element_rect(color="black", linewidth=gg_lwd_convert(1)),
              axis.line = element_blank(),
              legend.position="right",
              legend.title = element_blank(),
              legend.text= element_text(color="black", size=font_size),
              plot.title = element_text(hjust=0.5, color="black", size=font_size),
              axis.text = element_text(color="black", size=font_size),
              axis.title = element_text(color="black", size=font_size),
            ) +
        labs(x="rank",y="Log2 fold change", title=title)

}


data <- read.table(file=data_table, header=T)
if(is.null(columns)) data <- data[,c("Row.names", "baseMean", "log2FoldChange", "padj")] else data <- data[, columns]
data <- na.omit(data)
columns <- colnames(data)
if((ncol(data) < 4) & (!"padj" %in% colnames(data))) data$padj <- 0
data <- data[,append(columns, "padj")]

if(plot_type == "volcano") {
    volcano.plot(data, output, title, labels)
}else if(plot_type == "ma") {
    ma.plot(data, output, title, labels)
}else if(plot_type == "rank") {
    rank.plot(data, output, title, labels)
}else volcano.plot(data, output, title, labels)

#!/usr/bin/env Rscript
# Plot Fragment proportion in Peaks regions (FRiPs).
library(argparse)
library(ggplot2)
library(viridis)
library(ggpubr)
library(ggrepel)
parser <- ArgumentParser()
parser$add_argument('input', type="character", help='inputfile, summary.xls')
parser$add_argument('-o', dest='outfig', type="character", required=TRUE, help='output fig')
args <- parser$parse_args()


data <- read.table(args$input, sep="\t", header=TRUE)

data$FRiPs <- data$reads_in_peaks*100/data$filtered_reads
data$samples <- factor(data$samples, levels=data$samples)
fig1A <- ggplot(data, aes(x=group, y=peaks_count, fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicates), position = position_jitter(0.15))+
  geom_text_repel(aes(label=peaks_count, x=group, y=peaks_count), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Number of Peaks") +
  xlab("") +
  ggtitle("1A. Number of Peaks")

fig1B <- ggplot(data, aes(x=group, y=reads_in_peaks/2000000, fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicates), position = position_jitter(0.15))+
  geom_text_repel(aes(label=round(reads_in_peaks/2), x=group, y=reads_in_peaks/2000000), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Fragments in Peaks regions per Million") +
  xlab("") +
  ggtitle("1B. Fragments in Peaks regions")

fig1C <- ggplot(data, aes(x=group, y=FRiPs, fill=group)) + 
  geom_boxplot() +
  geom_jitter(aes(color = replicates), position = position_jitter(0.15))+
  geom_text_repel(aes(label=paste0(as.character(round(FRiPs, 1)), "%"), x=group, y=FRiPs), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("% of Fragments in Peaks") +
  xlab("") +
  ggtitle("1C. Fragment proportion in Peaks regions (FRiPs)")

fig <- ggarrange(fig1A, fig1B, fig1C, ncol = 3, common.legend = TRUE, legend="right", widths=c(1,1,1.1))

ggsave(args$outfig, fig, width=12, height=9, bg="white")
extension <- tail(strsplit(args$outfig, split=".", fixed=T)[[1]], n=1)
prefix <- sub(extension, "", args$outfig)
ggsave(paste0(prefix, "Peaks.", extension), fig1A, width=10, height=7, bg="white")
ggsave(paste0(prefix, "FiPs.", extension), fig1B, width=10, height=7, bg="white")
ggsave(paste0(prefix, "FRiPs.", extension), fig1C, width=10, height=7, bg="white")

#!/usr/bin/env Rscript
library(argparse)

parser <- ArgumentParser()
parser$add_argument('input', type="character", help='input file.')
parser$add_argument('-x', dest='x_lable', type="character", default='', help='x lab.')
parser$add_argument('-y', dest='y_lable', type="character", default='', help='y lab.')
parser$add_argument('-t', dest='title', type="character", default='', help='title.')
parser$add_argument('--noheader', dest='noheader', action='store_true', help='if no header.')
parser$add_argument('-c', dest='column', type="integer", nargs="+", default=c(1,2), help='use column to calculate.')
parser$add_argument('-o', dest='output', type="character", required=TRUE, help='output.')
parser$add_argument('-w', dest='width', type="integer", default=12, help='outfig width.')
parser$add_argument('-l', dest='length', type="integer", default=9, help='outfig length.')
parser$add_argument('-b', dest='bin_width', type="double", default=0.5, help='bin width.')
parser$add_argument('-f', dest='font_size', type="integer", default=12, help='font size.')
parser$add_argument('--line', dest='line', action='store_true', help='add a line.')
parser$add_argument('--text', dest='text', action='store_true', help='add text.')
parser$add_argument('--ylog10', dest='ylog10', action='store_true', help='log10(y).')

args <- parser$parse_args()

library(ggplot2)
options(scipen=3)

if(args$noheader) {
    header <- FALSE
}else {
    header <- TRUE
}

stopifnot(length(args$column)==2)

df <- read.table(args$input, sep="\t", header=header)
df <- df[, args$column]
df <- df[complete.cases(df),]
df[,1] <- factor(df[,1], levels=df[, 1], ordered=TRUE)

if(args$ylog10) plot.y <- log10(df[,2]) else plot.y <- df[,2]

p <- ggplot(df) +
    geom_bar(aes(x=df[,1], y=plot.y), stat="identity", width=args$bin_width, fill="#FF000080") +
    labs(x=args$x_lable, y=args$y_lable, title=args$title) +
    theme_bw(base_size = 12) +
    theme(panel.grid=element_blank()) +
    theme(plot.title = element_text(hjust=0.5, face="bold", color="black", size=14)) +
    theme(axis.text.x = element_text(color='black',size=args$font_size)) +
    theme(axis.text.y = element_text(color='black',size=args$font_size)) +
    theme(panel.grid = element_blank())

if(args$line) {
    p <- p + geom_line(aes(x=df[,1], y=plot.y, group=1), stat="identity", color="red")
}

if(args$text) {
    p <- p + geom_text(aes(label=df[,2], x=df[,1], y=1.02*plot.y), color="black")
}

ggsave(p, filename = args$output, width = args$width, height = args$length)

#!/usr/bin/env Rscript
library(argparse)
library(ggplot2)
library(viridis)
library(ggpubr)
library(ggrepel)
parser <- ArgumentParser()
parser$add_argument('input', type="character", help='inputfile, summary.xls')
parser$add_argument('-o', dest='outfig', type="character", required=TRUE, help='output fig')
args <- parser$parse_args()


data <- read.table(args$input, sep="\t", header=TRUE)
data$samples <- factor(data$samples, levels=data$samples)

trim <- data.frame("samples"=rep(data$samples,2),
                   "withadapter"=c(data$read1_with_adapter, data$read2_with_adapter),
                   "withadapter_percent"=c(data$read1_with_adapter_percent, data$read2_with_adapter_percent),
                   "termini"=c(rep("read1", nrow(data)), rep("read2", nrow(data))))
                   
fig1A <- ggplot(data) + 
  geom_col(aes(x=samples, y=total_read_pairs/1000000, fill=samples)) +
  geom_jitter(data=trim, aes(x=samples, y=withadapter/1000000, color = termini), position = position_jitter(0.15))+
  # guides(color = guide_legend(override.aes = list(size=2))) + 
  geom_text_repel(aes(label=total_read_pairs, x=samples, y=total_read_pairs/1000000), color="black", segment.color="grey", size=2, direction='y') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank(), legend.position = "bottom") +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Read pairs per Million") +
  xlab("") +
  ggtitle("1A. Rawdata Read Pairs Count")

fig1B <- ggplot(trim, aes(x=samples, y=withadapter/1000000, fill=samples)) + 
  geom_boxplot() +
  geom_jitter(aes(color = termini), position = position_jitter(0.15))+
  geom_text_repel(aes(label=withadapter, x=samples, y=withadapter/1000000), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Reads with Adapter per Million") +
  xlab("") +
  ggtitle("1B. Reads with Adapter")

fig1C <- ggplot(trim, aes(x=samples, y=as.numeric(sub("%", "", withadapter_percent)), fill=samples)) + 
  geom_boxplot() +
  geom_jitter(aes(color = termini), position = position_jitter(0.15))+
  geom_text_repel(aes(label=withadapter_percent, x=samples, y=as.numeric(sub("%", "", withadapter_percent))), color="black", segment.color="grey", size=2, direction='both') +
  # geom_text(aes(label=withadapter_percent, x=samples, y=1.02*as.numeric(sub("%", "", withadapter_percent))), color="black")+
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("% of Reads with Adapter") +
  xlab("") +
  ggtitle("1C. Reads with Adapter(%)")

fig1 <- ggarrange(fig1A, fig1B, fig1C, ncol = 3, common.legend = TRUE, legend="bottom")

alignres <- data.frame("group"=data$group, "replicate"=data$replicates,
                       "sequencedepth"=data$input_read_pairs,
                       "mappedfragments"=data$mapped_read_pairs,
                       "alignmentrate"=data$alignment_rate)

fig2A <- ggplot(alignres, aes(x=group, y=sequencedepth/1000000, fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicate), position = position_jitter(0.15))+
  geom_text_repel(aes(label=sequencedepth, x=group, y=sequencedepth/1000000), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Sequencing Depth per Million") +
  xlab("") +
  ggtitle("2A. Sequencing Depth")


fig2B <- ggplot(alignres, aes(x=group, y=mappedfragments/1000000, fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicate), position = position_jitter(0.15))+
  geom_text_repel(aes(label=mappedfragments, x=group, y=mappedfragments/1000000), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Mapped Fragments per Million") +
  xlab("") +
  ggtitle("2B. Alignable Fragments")


fig2C <- ggplot(alignres, aes(x=group, y=as.numeric(sub("%", "", alignmentrate)), fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicate), position = position_jitter(0.15))+
  geom_text_repel(aes(label=alignmentrate, x=group, y=as.numeric(sub("%", "", alignmentrate))), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("% of Mapped Fragments") +
  xlab("") +
  ggtitle("2C. Alignment Rate")

fig2 <- ggarrange(fig2A, fig2B, fig2C, ncol = 3, common.legend = TRUE, legend="bottom")


dupdata <- data.frame("group"=data$group, "replicate"=data$replicates,
                      "duprate"=data$duplication_rate,
                      "uniquefragments"=data$mapped_read_pairs * (100 - as.numeric(sub("%", "", data$duplication_rate)))/100,
                      "libarysize"=data$filtered_reads)


fig3A <- ggplot(dupdata, aes(x=group, y=as.numeric(sub("%", "", duprate)), fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicate), position = position_jitter(0.15))+
  geom_text_repel(aes(label=duprate, x=group, y=as.numeric(sub("%", "", duprate))), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Duplication Rate (*100%)") +
  xlab("") +
  ggtitle("3A. Duplication Rate")


fig3B <- ggplot(dupdata, aes(x=group, y=uniquefragments/1000000, fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicate), position = position_jitter(0.15))+
  geom_text_repel(aes(label=round(uniquefragments), x=group, y=uniquefragments/1000000), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Unique Fragments per Million") +
  xlab("") +
  ggtitle("3B. Unique Fragments")

fig3C <- ggplot(dupdata, aes(x=group, y=libarysize/1000000, fill=group))+
  geom_boxplot() +
  geom_jitter(aes(color = replicate), position = position_jitter(0.15))+
  geom_text_repel(aes(label=libarysize, x=group, y=libarysize/1000000), color="black", segment.color="grey", size=2, direction='both') +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  scale_fill_viridis(discrete = TRUE, begin = 0.15, end = 0.85, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.15, end = 0.85) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Reads per Million") +
  xlab("") +
  ggtitle("3C. Final Library Size")


fig3 <- ggarrange(fig3A, fig3B, fig3C, ncol = 3, common.legend = TRUE, legend="bottom")

fig <- ggarrange(fig1, fig2, fig3, ncol=1)

ggsave(args$outfig, fig, width=12, height=12, bg="white")
extension <- tail(strsplit(args$outfig, split=".", fixed=T)[[1]], n=1)
prefix <- sub(extension, "", args$outfig)
ggsave(paste0(prefix, "fig1.", extension), fig1, width=10, height=7, bg="white")
ggsave(paste0(prefix, "fig2.", extension), fig2, width=10, height=7, bg="white")
ggsave(paste0(prefix, "fig3.", extension), fig3, width=10, height=7, bg="white")

#!/usr/bin/env Rscript
library(argparse)

parser <- ArgumentParser()
parser$add_argument('input', type="character", nargs="+", help='input file.')
parser$add_argument('-s', dest='samples', nargs="+", default=NULL, type="character", help='sample names.')
parser$add_argument('-t', dest='title', type="character", default='', help='title.')
parser$add_argument('--noheader', dest='noheader', action='store_true', help='if no header.')
parser$add_argument('-c', dest='column', type="integer", default=1, help='use column to calculate.')
parser$add_argument('-o', dest='outdir', type="character", required=TRUE, help='output dir.')
parser$add_argument('-p', dest='pdf', action='store_true', help='pdf or png')
parser$add_argument('--name_size', dest='name_size', type="integer", default=5, help='name size.')
parser$add_argument('--text_size', dest='text_size', type="integer", default=4, help='text size.')
parser$add_argument('--show_percentage', dest='show_percentage', action='store_true', help='show percentage')

args <- parser$parse_args()

library(ggvenn)
library(ggplot2)

outdir <- args$outdir
pdf <- args$pdf

filesnum <- length(args$input)

samples <- args$samples

if(is.null(samples)) {
    samples <- 1:filesnum
}

stopifnot(filesnum==length(samples))

if(args$noheader) {
    header <- FALSE
}else {
    header <- TRUE
}

data <- list()

for(idx in 1:filesnum) {
    table <- read.table(args$input[idx], sep="\t", header=header)
    table <- table[, args$column]
    data[[samples[idx]]] <- table
}

if(!dir.exists(outdir)) {
    dir.create(outdir, recursive=TRUE)
}

if(pdf) {
    pdf(file.path(outdir, "venn.pdf"), width=540, height=480)
}else {
    png(file.path(outdir, "venn.png"), width=540, height=480)
}

ggvenn(data, samples, show_percentage = args$show_percentage,
    stroke_color = "black",
    fill_color = c("#E41A1C","#1E90FF","#FF8C00", "#4DAF4A","#984EA3"),
    set_name_size = args$name_size,
    text_size = args$text_size
    ) + labs(title=args$title) + theme(plot.title = element_text(face="bold", hjust=0.5, color="black", size=14))

dev.off()

#!/usr/bin/env Rscript
library(argparse)
library(ggplot2)
library(viridis)
library(ggpubr)
library(dplyr)

parser <- ArgumentParser()
parser$add_argument('input', type="character", help='input file.')
parser$add_argument('-o', dest='outfig', type="character", required=TRUE, help='output fig')
parser$add_argument('-s', dest='samples', type="character", nargs='+', required=TRUE, help='sample names.')
parser$add_argument('-g', dest='group', type="character", nargs='+', required=TRUE, help='sample groups.')
parser$add_argument('-r', dest='replicate', type="character", nargs='+', required=TRUE, help='sample replicate.')
parser$add_argument('-m', dest='min_size', type="integer", default=100, help='min size.')
args <- parser$parse_args()

minlen <- args$min_size

data <- read.table(args$input, header=TRUE)

samples <- args$samples
group <- args$group
replicate <- args$replicate

data_info <- data.frame("Sample"=samples, "group"=group, "replicate"=replicate)

data <- merge(data, data_info, by="Sample")
data$weight <- data$Occurrences/sum(data$Occurrences)
data$Sample <- factor(data$Sample, levels=samples)
data$group <- factor(data$group, levels=unique(group))

max_col <- data[which(data$Occurrences==max(data$Occurrences),arr.ind=TRUE),]

data2 <- data %>% group_by(Size) %>% summarise("Occ"=sum(Occurrences))
max_Occ <- data2[which(data2$Occ==max(data2$Occ), arr.ind=TRUE),]

fig1A <- ggplot(data, aes(x = Sample, y = Size, weight = weight, fill = group)) +
  geom_violin(bw=5) +
  scale_y_continuous(breaks = seq(minlen, 1000, 50)) +
  scale_fill_viridis(discrete = TRUE, begin = 0.1, end = 0.9, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.1, end = 0.9) +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Peak Length") +
  xlab("") +
  coord_cartesian(ylim = c(minlen, 1000)) +
  ggtitle("1A. Peak Length Distribution(violin plot)")

fig1B <- ggplot(data, aes(x = Size, y = Occurrences, group=Sample, color = Sample)) +
  geom_line(size = 1) +
  geom_text(label=max_col$Size, x=max_col$Size+30, y=max_col$Occurrences, color="black", size=2, check_overlap=T) +
  scale_color_viridis(discrete = TRUE, begin = 0.1, end = 0.9, option = "turbo") +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  xlab("Peak Length") +
  ylab("Count") +
  coord_cartesian(xlim = c(minlen, 1000))+
  ggtitle("1B. Peak Length Distribution(line plot)")

fig1C <- ggplot(data, aes(x = Sample, y = Size, weight = weight, fill = group)) +
  geom_boxplot(outlier.shape=NA) +
  scale_y_continuous(breaks = seq(minlen, 1000, 50)) +
  scale_fill_viridis(discrete = TRUE, begin = 0.1, end = 0.9, option = "turbo", alpha = 0.8) +
  # scale_color_viridis(discrete = TRUE, begin = 0.1, end = 0.9) +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  ggpubr::rotate_x_text(angle = 20) +
  ylab("Peak Length") +
  xlab("") +
  coord_cartesian(ylim = c(minlen, 1000)) +
  ggtitle("1C. Peak Length Distribution(box plot)")

fig1D <- ggplot(data, aes(x = Size, y = Occurrences, group=Sample, fill = Sample)) +
  geom_col(position = "stack") +
  geom_text(label=max_Occ$Size, x=max_Occ$Size+30, y=max_Occ$Occ, color="black", size=2, check_overlap=T) +
  scale_fill_viridis(discrete = TRUE, begin = 0.1, end = 0.9, option = "turbo") +
  theme_bw(base_size = 12) +
  theme(panel.grid=element_blank()) +
  xlab("Peak Length") +
  ylab("Count") +
  coord_cartesian(xlim = c(minlen, 1000))+
  ggtitle("1D. Peak Length Distribution(bar plot)")

fig <- ggarrange(fig1A, fig1B, fig1C, fig1D, ncol = 2, nrow=2)

ggsave(args$outfig, fig, width=12, height=9, bg="white")
extension <- tail(strsplit(args$outfig, split=".", fixed=T)[[1]], n=1)
prefix <- sub(extension, "", args$outfig)
ggsave(paste0(prefix, "violin.", extension), fig1A, width=10, height=7, bg="white")
ggsave(paste0(prefix, "line.", extension), fig1B, width=10, height=7, bg="white")
ggsave(paste0(prefix, "box.", extension), fig1C, width=10, height=7, bg="white")
ggsave(paste0(prefix, "bar.", extension), fig1D, width=10, height=7, bg="white")

#！/bin/sh
if [ $# != 2 ];then
    echo "Usage: gtfparser.sh gencode.v32.annotation.gtf hg38"
    exit 1;
fi

GTF=$1
PREFIX=$2

## gtf2bed12
gtfToGenePred $GTF $PREFIX.genePhred && genePredToBed $PREFIX.genePhred $PREFIX.bed12 && rm $PREFIX.genePhred


## gtf2intron
awk -v OFS="\t" '{if($3=="gene"){match($0,/gene_id "(\S*)"/,a);print $1,$4-1,$5,a[1],$6,$7}}' $GTF > $PREFIX.gene.bed
awk -v OFS="\t" '{if($3=="transcript"){match($0,/transcript_id "(\S*)"/,a);print $1,$4-1,$5,a[1],$6,$7}}' $GTF > $PREFIX.transcript.bed
awk -v OFS="\t" '{if($3=="exon"){match($0,/transcript_id "(\S*)"/,a);print $1,$4-1,$5,a[1],$6,$7}}' $GTF > $PREFIX.exon.bed
awk -v OFS="\t" '{print $4,$2,$3,$1,$5,$6}' $PREFIX.transcript.bed > transcript.reverse.bed && \
awk -v OFS="\t" '{print $4,$2,$3,$1,$5,$6}' $PREFIX.exon.bed > exon.reverse.bed && \
bedtools subtract -a transcript.reverse.bed -b exon.reverse.bed -s | awk -v OFS="\t" '{print $4,$2,$3,$1,$5,$6}' > $PREFIX.intron.bed && \
rm transcript.reverse.bed exon.reverse.bed

#!/bin/sh
if [ $# != 5 ];then
    echo "Usage: remove_duplicates.sh threads read1.fq.gz read2.fq.gz out1.fq.gz out2.fq.gz"
    exit 1;
fi
# Accept parameters.
threads=$1
read1=$2
read2=$3
out1=$4
out2=$5

# Define temp filles.
prefix=$out1
tempdir=${prefix}.temp
decompressed1=${prefix}.temp/R1.decompressed.fastq
decompressed2=${prefix}.temp/R2.decompressed.fastq
uncompress1=${prefix}.temp/R1.undecompress.fastq
uncompress2=${prefix}.temp/R2.undecompress.fastq

# Run.
mkdir -p $tempdir
pigz -p $threads -d -c $read1 > $decompressed1
pigz -p $threads -d -c $read2 > $decompressed2

echo processing $read1 $read2 ...
echo -e "input read pairs: \c"
((input_num=`cat $decompressed1 | wc -l` / 4))
echo $input_num

paste $decompressed1 $decompressed2 | \
    awk '{if(NR%4==0){printf $0"\n"}else{printf $0"\t"}}' | \
    sort -T $tempdir -t $'\t' -k3,4 -u | \
    awk -v FS='\t' '{print $1"\n"$3"\n"$5"\n"$7 > "'$uncompress1'"; print $2"\n"$4"\n"$6"\n"$8 > "'$uncompress2'"}'

echo -e "output read pairs: \c"
((output_num=`cat $uncompress1 | wc -l` / 4))
echo $output_num

echo -e "duplicate ratio: \c"
awk 'BEGIN{printf"%.2f%\n",('$[$input_num-$output_num]'/'$input_num')*100}'
pigz -p $threads -c $uncompress1 > $out1
pigz -p $threads -c $uncompress2 > $out2

# Remove temp files.
rm -r $tempdir

#！/bin/sh
if [ $# != 1 ];then
    echo "Usage: fastq_len.sh input.fa"
    exit 1;
fi

zcat $1 | awk '{if(NR%4==2)print length}' | sort | uniq -c | awk 'BEGIN{OFS="\t";print "Length\tCount"}{print $2,$1}'

#!/bin/sh
if [ $# != 3 ];then
    echo "Usage: merge_subseq.sh threads input.fa outdir"
    exit 1;
fi

threads=$1
fasta=$2
outdir=$3

mkdir -p $outdir/bowtie_index

bowtie-build --threads $threads $fasta $outdir/bowtie_index/ref

bowtie -p $threads -x $outdir/bowtie_index/ref $fasta -f -a -v 0 --norc -S $outdir/mapped.sam 2> $outdir/mapped.log

samtools view $outdir/mapped.sam | awk '$1 != $3' | cut -f 1,3 > $outdir/overlap.reads.txt
rm $outdir/mapped.sam

subseq_analysis -f $fasta -o $outdir -r $outdir/overlap.reads.txt > $outdir/collapse_seq.log
